#!/usr/bin/perl
use strict;
use warnings;
use utf8;
use CGI::Fast;
use CGI::Carp qw(fatalsToBrowser warningsToBrowser);
use CGI qw(:standard);
use Encode;
use CGI;
use DBI;
use Digest::MD5;

use lib '.';
use templates;
my $time_start = 1514120000;
my $time_end = 1515369599;

# PLAN
# 0. Connect to DB
# 1. Retrive unique IDs (cookies, ip, specs? I dunno, but don't be intrusive about it. Tracking pixel may be a nice idea, though. But it would need to come from a diferent resource.... choices, choices)
# 2. Check on completeness (e.g. not started, page 1, page 5, already finished) and serve what is needed, based on ids.
# 3. Record answers in db, advance stage
#
# DB
# 1. Table for corresponding the: respondent number, their ip, cookie and other tracking info. No PK, so storing multiple values for each should be legal.
# 2. Table for each page.
# 2.1. Date of birth, city, board age NOT NULL
# 2.2. board_name/id, freq, begin_date, end_date, 'original', 'current'
# 2.3.1 script_name/id, reason
# 2.3.2 usertyle_name/id
# 2.3.3 functionality_string
# 2.3.4 additional_func, id, user_id/func_session_id
# 2.4 hobby_name/id, skill_lvl, time_practicing, frequ, eq_work, eq_irl, ii_joint
# 2.5 moderation_affection, meme_affection, avatar_affection
# 2.5.1 mod_level, ban_severity, mod_contact, mod_discrepancy (различия меж разделами), boards_closed, overall_course
# 2.5.2 meme_name/id, affection
# 2.5.3 fag_name/id, affection
# 2.6.1 previous_questioneers
# 2.6.2 Quest_id, compare_easiness, compare_coverage, compare_design
# 2.6.3 thoughts_about_questioneer, overall_easiness, overall_coverage, overall_design
# 3. Table for corresponding respondent number and 'completeness' of questionere
# 4. Table of trustworthines of respondent
my $dbh=DBI->connect("###",'###','###',{AutoCommit=>0,RaiseError=>1});
use constant SURVEY_SCHEMA=>'###';
=begin comment
make_db();
exit(0);
=end comment
=cut
$dbh->do("SET SCHEMA '".SURVEY_SCHEMA."'");
my $pid;
while (my $query = CGI::Fast->new){
	my $page=$query->param("page");
	my $stage;
	die if $pid==1;
	$pid = $query->param("pid") if defined($query->param("pid"));
	die if $pid==1;
	if(time() < $time_start || time() > $time_end)
	{
		if(!defined $page){
			print "Status: 404 Not Found\n\n";
			exit(0);
		}
		else{
			$stage = $page;
		}
	}

	my $id=$pid;

	my $cookie_val = Digest::MD5::md5_hex($ENV{REMOTE_ADDR});
	my $sth = $dbh->prepare_cached("SELECT MIN(identity), COUNT(ip) FROM ips WHERE ip = ? UNION ALL SELECT MIN(identity), COUNT(cookie) FROM cookies WHERE cookie=?");
if(!defined($id)){
	my $c = $query->cookie(SURVEY_SCHEMA.'_id') || undef;
	$sth->execute($ENV{REMOTE_ADDR},$c);
	my @resp = @{$sth->fetchall_arrayref()};

	if(!($resp[0][1] or $resp[1][1])) {
		$resp[0][0] = $resp[0][0] or $resp[1][0];
	}
	$id = $resp[0][0] or $resp[1][0];

	if(!defined $id) {
		$dbh->do("INSERT INTO identities (stage) VALUES (0)") or die;
		$sth = $dbh->prepare_cached("SELECT MAX(identity) FROM identities") or die;
		$sth->execute() or die;
		my $r = $sth->fetchrow_arrayref() or die;
		$id = $$r[0] or die;
	}
	unless ($resp[0][1]) {
		$sth = $dbh->prepare_cached("INSERT INTO ips VALUES(?,?)") or die;
		$sth->execute($ENV{REMOTE_ADDR}, $id) or die;
	}
	unless ($resp[1][1]) {
		my $cookie_val = Digest::MD5::md5_hex($ENV{REMOTE_ADDR});
		print "Set-Cookie: ".SURVEY_SCHEMA."_id=$cookie_val; Expires=Mon, 08 Jan 2018 00:00:00 GMT\n";
		$sth = $dbh->prepare_cached("INSERT INTO cookies VALUES(?,?) ON CONFLICT DO NOTHING");
		$sth->execute($cookie_val, $id);
	}
}
	$sth = $dbh->prepare_cached("SELECT stage FROM identities WHERE identity=?");
	$sth->execute($id);
	my $r = $sth->fetchrow_arrayref();
	$stage = $$r[0] unless defined $stage;
	if ($query->param('task') eq 'reset' and decode(utf8=>$query->param('id')) eq $id) {
		$sth = $dbh->prepare_cached("UPDATE identities SET stage=1 WHERE identity=?");
		$sth->execute($id);
	}

	if ($ENV{REQUEST_METHOD} eq 'POST') {
		if ($query->param('prev')) {
			$stage -= 1 if $stage;
			$sth = $dbh->prepare_cached("UPDATE identities SET stage=? WHERE identity=?") or die;
			$sth->execute($stage,$id) or die $id;
		}
		else {
			my $sth=$dbh->prepare_cached("SELECT q_id FROM question_ids WHERE identity=? AND stage=?");
			$sth->execute($id,$stage);
			my @res = $sth->fetchrow_array();
			my $prev_q_id = $res[0];
			if ($prev_q_id) {
				$sth=$dbh->prepare_cached("DELETE FROM question_ids WHERE q_id = ?");
				$sth->execute($prev_q_id);
			}
			my @chars = ("A".."Z", "a".."z", '0'..'9'); my $q_id; $q_id .= $chars[rand @chars] for 1..64;
			$q_id.=time();
			$sth = $dbh->prepare_cached("INSERT INTO question_ids VALUES(?,?,?)");
			$sth->execute($id,$stage,$q_id);
			if (!$stage and $query->param('task') eq 'start') {
				$sth = $dbh->prepare_cached("UPDATE identities SET stage=? WHERE identity=?") or die;
				$sth->execute(1,$id) or die $id;
			}
			elsif ($stage == 1 and defined $query->param('board_age')) {
				$sth = $dbh->prepare_cached("INSERT INTO bio VALUES(?,?,?,?,?,?)") or die;
				my ($age, $city, $bage, $male, $comment) = ($query->param('age') || undef,decode(utf8=>$query->param('city')) || undef,$query->param('board_age'),$query->param('sex') eq 'male' ? '1' : ($query->param('sex') eq 'female' ? '0' : undef),decode(utf8=>$query->param('comment')) || undef);
				$sth->execute($q_id,$age,$city,$bage,$male, $comment);
				$sth = $dbh->prepare_cached("UPDATE identities SET stage=? WHERE identity=?") or die;
				$sth->execute(2,$id);
			}
			elsif ($stage == 2) {
				#I wanted to try regexp verification thingy~~
				my $sth = $dbh->prepare_cached("INSERT INTO boards VALUES(?,?,?,?,?,?)") or die;
				my $c = 0;
				my @boards = $query->param('board_name');
				my @subboards = $query->param('subboard');
				my @stay_period = $query->param('stay_period');
				my @ids = $query->param('id');
				for (@ids) {
					my %h = map { $_, 1 } $query->param('board'.$_);
					for ('origin','main') {
						$h{$_} = (defined $h{$_}) ? 'true' : 'false';
					}
					my ($b,$sb,$sp,$o,$m) = (decode(utf8=>$boards[$c]),decode(utf8=>$subboards[$c]) || '*',decode(utf8=>$stay_period[$c]) || undef,$h{origin},$h{main});
					$sth->execute($q_id,$b,$sb,$sp,$o,$m) or die;
					$c+=1;
				}
				$sth = $dbh->prepare_cached("UPDATE identities SET stage=? WHERE identity=?");
				$sth->execute(3,$id);
			}
			elsif ($stage == 3) {
				$sth = $dbh->prepare_cached("INSERT INTO scripts VALUES(?,?,?,?)");
				my $c = 0;
				my @userscripts = $query->param('scripts');
				my @reasons = $query->param('reason_scripts');
				for (@userscripts) {
					my $r = $reasons[$c] || undef;
					$sth->execute($q_id,'script',decode(utf8=>$_),decode(utf8=>$r));
					$c+=1;
				}
				my @mirrors = $query->param('mirrors');
				@reasons = $query->param('reason_mirrors');
				$c = 0;
				for (@mirrors) {
					my $r = $reasons[$c] || undef;
					$sth->execute($q_id,'mirror',decode(utf8=>$_),decode(utf8=>$r));
					$c+=1;
				}
				my @clients = $query->param('clients');
				@reasons = $query->param('reason_clients');
				$c = 0;
				for (@clients) {
					my $r = $reasons[$c] || undef;
					$sth->execute($q_id,'client',decode(utf8=>$_),decode(utf8=>$r));
					$c+=1;
				}
				$sth = $dbh->prepare_cached("INSERT INTO styles VALUES(?,?)");
				my @stylesheets = $query->param('stylesheets');
				for (@stylesheets) {
					$sth->execute($q_id,decode(utf8=>$_));
				}
				$sth = $dbh->prepare_cached("INSERT INTO features VALUES(?,?,?)");
				my %ex = (scripts=>1,reason=>1,stylesheets=>1,used=>1,hate=>1,bug_abuse=>1,feature_comment=>1,page=>1,essoteric=>1,mod=>1,clients=>1,mirrors=>1);
				for my $p ($query->param) {
					if (not $ex{$p}) {
						my $tmp = $query->param($p);
						$sth->execute($q_id,$p,$tmp);
					}
				}
				$sth = $dbh->prepare_cached("UPDATE identities SET stage=? WHERE identity=?");
				$sth->execute(4,$id);
				$sth = $dbh->prepare_cached("INSERT INTO misc VALUES(?,?,?)");
				for ('bug_abuse','feature_comment','essoteric','mod') {
					my $tmp = decode(utf8=>$query->param($_)) || undef;
					$sth->execute($q_id,$_,$tmp);
				}
			}
			elsif ($stage == 4) {
				my %hobbies = (playing_music=>1,composing_music=>1,listening_music=>1,drawing=>1,modelling=>1,viewing=>1,taking_pictures=>1,shooting=>1,streaming=>1,watching=>1,watching_anime=>1,coding=>1,gaming=>1,reading=>1,reading_co=>1,writing=>1,cosplaying=>1,figurine_collecting=>1,tourism=>1);
				my %params = map {$_ => 1} $query->param;
				$sth = $dbh->prepare_cached("INSERT INTO hobbies VALUES (?,?,?,?,?,?,?,?,?)");

				for my $hobby (keys %hobbies) {
					if($query->param($hobby)){
						delete $params{$hobby};
						my @a;
						my $c = 0;
						for ('howlong','board_shared','board_primary','board_exclusive','job_shared','collection_size','genre'){
							push @a, decode(utf8=>$query->param($hobby.'_'.$_)) || (($c > 0 && $c < 5)? 0 : undef);
							delete $params{$hobby.'_'.$_};
							$c+=1;
						}
						$sth->execute($q_id,$hobby,@a);
					}
				}
				for my $hobby (keys %params){
					if ($hobby =~ /^other_hobby\d+$/){
						my @a;
						my $c = 0;
						for ('howlong','board_shared','board_primary','board_exclusive','job_shared','collection_size','genre'){
							push @a, decode(utf8=>$query->param($hobby.'_'.$_)) || (($c > 0 && $c < 5 || defined $query->param($hobby.'_'.$_))? 0 : undef);
							delete $params{$hobby.'_'.$_};
							$c+=1;
						}
						$sth->execute($q_id,decode(utf8=>$query->param($hobby)),@a);	
						my $sth2 =$dbh->prepare_cached("INSERT INTO misc VALUES(?,?,?)");
						$sth2->execute($q_id,decode(utf8=>$query->param($hobby)).'_other',decode(utf8=>$query->param($hobby.'_other')));
						delete $params{$hobby.'_other'};
						delete $params{$hobby};
					}
				}
				$sth =$dbh->prepare_cached("INSERT INTO misc VALUES(?,?,?)");
				for my $misc (keys %params) {
					my @tmp = split('_',$misc);
					for ($query->param($misc)) {
						if ($_ && ($query->param($tmp[0]) || $query->param($tmp[0].'_'.$tmp[1]))){
							$sth->execute($q_id,$misc,decode(utf8=>$_));
						}
					}
				}
				$sth = $dbh->prepare_cached("UPDATE identities SET stage=? WHERE identity=?");
				$sth->execute(5,$id);
			}
			elsif ($stage == 5) {
				for my $param ($query->param) {
					if ($param ne 'page' && ($param =~ /overall/ || $query->param((split('_',$param))[0].'_full'))) {
						$sth = $dbh->prepare_cached("INSERT INTO misc VALUES(?,?,?)");
						my $p = $query->param($param);
						$sth->execute($q_id,decode(utf8=>$param),decode(utf8=>$p));
					}
				}
				$sth = $dbh->prepare_cached("UPDATE identities SET stage=? WHERE identity=?");
				$sth->execute(6,$id);
			}
			elsif ($stage == 6 || $stage == 7 || $stage == 8) {
				for my $param ($query->param) {
					unless ($param eq 'page') {
						$sth = $dbh->prepare_cached("INSERT INTO misc VALUES(?,?,?)");
						for ($query->param($param)) {
							my $p = $_;
							$sth->execute($q_id,decode(utf8=>$param),decode(utf8=>$p));
						}
					}
				}
				$sth = $dbh->prepare_cached("UPDATE identities SET stage=? WHERE identity=?");
				$stage=$stage+1;
				$sth->execute($stage,$id);
				$stage=$stage-1;
			}
			elsif ($stage == 9) {
				$sth = $dbh->prepare_cached("UPDATE identities SET stage=? WHERE identity=?");
				$sth->execute(10,$id);
			}
			elsif ($query->param('task') eq 'reset' and $query->param('id') eq $id) {
				$sth = $dbh->prepare_cached("UPDATE identities SET stage=? WHERE identity=?");
				$sth->execute(0,$id);
			}
		}
		$stage+=1 unless $stage == 1 and ! defined $query->param('board_age') or $query->param('prev');
		print "Status: 303 Go West\n";
		print "Location: /survey.pl?pid=$pid&page=$stage\n";
		print "Set-Cookie: ".SURVEY_SCHEMA."_id=$cookie_val; Expires=Mon, 08 Jan 2018 00:00:00 GMT\n";
		print "\n";
	}
	elsif ($ENV{REQUEST_METHOD} eq 'GET') {
		print "Content-Type: text/html; charset=utf-8\n";
		print "Set-Cookie: ".SURVEY_SCHEMA."_id=$cookie_val; Expires=Mon, 08 Jan 2018 00:00:00 GMT\n";
		print "\n";
		my $sth = $dbh->prepare_cached("SELECT q_id FROM question_ids WHERE stage=? AND identity=? LIMIT 1");
		$sth->execute($stage,$id);
		my @res = $sth->fetchrow_array();
		my $q_id = $res[0];
		if (defined $page && (time() < $time_start || time() > $time_end)) {
			$stage = $page;
		}
		if (!$stage) {
			print main_notice();
		}
		elsif ($stage == 1) {
			$sth=$dbh->prepare_cached("SELECT * FROM bio WHERE q_id = ?");
			$sth->execute($q_id);
			my $res = $sth->fetchrow_hashref();
			print page_1(%{$res});
		}
		elsif ($stage == 2) {
			$sth=$dbh->prepare_cached("SELECT * FROM boards WHERE q_id = ?");
			$sth->execute($q_id);
			my @replies;
			while (my $res = $sth->fetchrow_hashref()){
				push @replies, $res;
			}
			unless (scalar @replies) {
				@replies = ({1=>1},);
			}
			print page_2(@replies);
		}
		elsif ($stage == 3) {
			$sth=$dbh->prepare_cached("SELECT * FROM scripts WHERE q_id = ?");
			$sth->execute($q_id);
			my @scripts;
			while (my $res = $sth->fetchrow_hashref()){
				push @scripts, $res;
			}
			unless (scalar @scripts) {
				@scripts = ({1=>1},);
			}
			$sth=$dbh->prepare_cached("SELECT style FROM styles WHERE q_id = ?");
			$sth->execute($q_id);
			my %styles;
			while (my @res = $sth->fetchrow_array()){
				$styles{$res[0]} = 1;
			}
			$sth=$dbh->prepare_cached("SELECT * FROM features WHERE q_id = ?");
			$sth->execute($q_id);
			my %features;
			while (my @res = $sth->fetchrow_array()){
				my $n = $res[1];
				$features{$n} = $res[2];
			}
			unless (scalar keys %features) {
				%features = ({1=>1},);
			}
			$sth=$dbh->prepare_cached("SELECT * FROM misc WHERE q_id = ?");
			$sth->execute($q_id);
			my %replies;
			while (my @res = $sth->fetchrow_array()){
				$replies{$res[1]} = $res[2];
			}
			unless (keys %replies) {
				%replies = ({1=>1},);
			}
			print page_3(\@scripts,\%styles,\%features,\%replies);
		}
		elsif ($stage == 4) {
			$sth=$dbh->prepare_cached("SELECT * FROM hobbies WHERE q_id = ?");
			$sth->execute($q_id);
			my %hobbies;
			while (my @res = $sth->fetchrow_array()){
				my $n = $res[1];
				splice @res,0,2;
				$hobbies{$n} = \@res;
			}
			unless (scalar keys %hobbies) {
				%hobbies = ();
			}
			$sth=$dbh->prepare_cached("SELECT * FROM misc WHERE q_id = ?");
			$sth->execute($q_id);
			my %replies;
			while (my @res = $sth->fetchrow_array()){
				unless(defined $replies{$res[1]}) {
					$replies{$res[1]} = $res[2];
				}
				elsif(ref($replies{$res[1]}) eq 'ARRAY'){
					push @{$replies{$res[1]}},$res[2];
				}
				else {
					$replies{$res[1]} = [$replies{$res[1]},$res[2]];
				}
			}
			unless (keys %replies) {
				%replies = ({1=>1},);
			}
			print page_4(\%hobbies,\%replies);
		}
		elsif ($stage == 5) {
			$sth=$dbh->prepare_cached("SELECT * FROM misc WHERE q_id = ?");
			$sth->execute($q_id);
			my %replies;
			while (my @res = $sth->fetchrow_array()){
				$replies{$res[1]} = $res[2];
			}
			unless (keys %replies) {
				%replies = ({1=>1},);
			}
			print page_5(\%replies);
		}
		elsif ($stage == 6) {
			$sth=$dbh->prepare_cached("SELECT * FROM misc WHERE q_id = ?");
			$sth->execute($q_id);
			my %replies;
			while (my @res = $sth->fetchrow_array()){
				unless(defined $replies{$res[1]}) {
					$replies{$res[1]} = [$res[2],];
				}
				elsif(ref($replies{$res[1]}) eq 'ARRAY'){
					push @{$replies{$res[1]}},$res[2];
				}
				else {
					$replies{$res[1]} = [$replies{$res[1]},$res[2]];
				}
			}
			unless (keys %replies) {
				%replies = ({1=>1},);
			}
			print page_6(%replies);
		}
		elsif ($stage == 7) {
			$sth=$dbh->prepare_cached("SELECT * FROM misc WHERE q_id = ?");
			$sth->execute($q_id);
			my %replies;
			while (my @res = $sth->fetchrow_array()){
				unless(defined $replies{$res[1]}) {
					$replies{$res[1]} = [$res[2],];
				}
				elsif(ref($replies{$res[1]}) eq 'ARRAY'){
					push @{$replies{$res[1]}},$res[2];
				}
				else {
					$replies{$res[1]} = [$replies{$res[1]},$res[2]];
				}
			}
			unless (keys %replies) {
				%replies = ({1=>1},);
			}
			print page_7(%replies);
		}
		elsif ($stage == 8) {
			$sth=$dbh->prepare_cached("SELECT * FROM misc WHERE q_id = ?");
			$sth->execute($q_id);
			my %replies;
			while (my @res = $sth->fetchrow_array()){
				$replies{$res[1]} = $res[2];
			}
			unless (keys %replies) {
				%replies = (1=>1,);
			}
			print page_8(%replies);
		}
		elsif ($stage == 9) {
			print prefinal();
		}
		elsif ($stage == 10) {
			print final($id);
		}
		else {
			print demo_notice();
		}
	}
	else {
		print "Status: 405 Method Not Allowed\n";
		print "Allow: GET, POST\n";
		print "\n";
	}
	$dbh->commit();

}

sub make_db {
	$dbh->do("DROP SCHEMA IF EXISTS ".SURVEY_SCHEMA." CASCADE");
	$dbh->do("CREATE SCHEMA ".SURVEY_SCHEMA);
	$dbh->do(q"
		CREATE TABLE IF NOT EXISTS ".SURVEY_SCHEMA.".identities (
			identity	SERIAL PRIMARY KEY,
			stage		INTEGER NOT NULL
		);");
	$dbh->do(q"
		CREATE TABLE IF NOT EXISTS ".SURVEY_SCHEMA.".question_ids (
			identity	INTEGER REFERENCES ".SURVEY_SCHEMA.".identities (identity) ON DELETE CASCADE,
			stage		INTEGER NOT NULL,
			q_id		TEXT PRIMARY KEY
		);");
	$dbh->do(q"
		CREATE TABLE IF NOT EXISTS ".SURVEY_SCHEMA.".ips (
			ip		CIDR PRIMARY KEY,
			identity	INTEGER REFERENCES ".SURVEY_SCHEMA.".identities (identity)
		);");
	$dbh->do(q"
		CREATE TABLE IF NOT EXISTS ".SURVEY_SCHEMA.".cookies (
			cookie		TEXT PRIMARY KEY,
			identity	INTEGER REFERENCES ".SURVEY_SCHEMA.".identities (identity)
		);");
	$dbh->do(q"
		CREATE TABLE IF NOT EXISTS ".SURVEY_SCHEMA.".bio (
			q_id		TEXT PRIMARY KEY REFERENCES ".SURVEY_SCHEMA.".question_ids (q_id) ON DELETE CASCADE,
			age		INTEGER,
			city		TEXT,
			board_age	REAL NOT NULL,
			male		BOOLEAN,
			comments	TEXT
		);");
	$dbh->do(q"
		CREATE TABLE IF NOT EXISTS ".SURVEY_SCHEMA.".boards (
			q_id		TEXT REFERENCES ".SURVEY_SCHEMA.".question_ids (q_id) ON DELETE CASCADE,
			board		TEXT,
			subboard	TEXT NOT NULL DEFAULT '*',
			stay_period	TEXT,
			first		BOOLEAN NOT NULL DEFAULT FALSE,
			prima		BOOLEAN NOT NULL DEFAULT FALSE
		);");
	$dbh->do(q"
		CREATE TABLE IF NOT EXISTS ".SURVEY_SCHEMA.".scripts (
			q_id		TEXT REFERENCES ".SURVEY_SCHEMA.".question_ids (q_id) ON DELETE CASCADE,
			cat		TEXT NOT NULL,
			script		TEXT NOT NULL,
			reason		TEXT
		);");
	$dbh->do(q"
		CREATE TABLE IF NOT EXISTS ".SURVEY_SCHEMA.".styles (
			q_id		TEXT REFERENCES ".SURVEY_SCHEMA.".question_ids (q_id) ON DELETE CASCADE,
			style		TEXT
		);");
	$dbh->do(q"
		CREATE TABLE IF NOT EXISTS ".SURVEY_SCHEMA.".features (
			q_id		TEXT REFERENCES ".SURVEY_SCHEMA.".question_ids (q_id) ON DELETE CASCADE,
			feature		TEXT,
			attitude	TEXT NOT NULL DEFAULT 'dc'
		);");
	$dbh->do(q"
		CREATE TABLE IF NOT EXISTS ".SURVEY_SCHEMA.".hobbies (
			q_id		TEXT REFERENCES ".SURVEY_SCHEMA.".question_ids (q_id) ON DELETE CASCADE,
			hobby_name	TEXT NOT NULL,
			age		REAL,
			board_shared	BOOLEAN NOT NULL DEFAULT FALSE,
			board_oriented	BOOLEAN NOT NULL DEFAULT FALSE,
			board_exclusive	BOOLEAN NOT NULL DEFAULT FALSE,
			is_work		BOOLEAN NOT NULL DEFAULT FALSE,
			collection_size	REAL,
			genre		TEXT
		);");
	$dbh->do(q"
		CREATE TABLE IF NOT EXISTS ".SURVEY_SCHEMA.".misc (
			q_id		TEXT REFERENCES ".SURVEY_SCHEMA.".question_ids (q_id) ON DELETE CASCADE,
			question	TEXT,
			answer		TEXT
		);");
	$dbh->commit();
}
