use strict;
use utf8;
use Try::Tiny;
use constant HEADER => q|
<!DOCTYPE html>
<html>
	<head>
		<meta charset="utf-8" />
		<title>Всеычанский опрос 2017 (SoPC)</title>
		<link rel="stylesheet" type="text/css" href="survey.css" />
		<script type="text/javascript" src="survey.js"></script>
	</head>
	<body><div class="main-cont">|;

use constant FOOTER => q|
			<br />
			<div>
			<input id="prev" type="submit" name="prev" value="Назад" onclick="document.forms[0].setAttribute('novalidate','on')"/>
			<input id="submit" type="submit" value="Сохранить и продолжить" /></div>
		</form>
	<br />
	</div>
	</body>
</html>|;

sub demo_notice {
	return HEADER.q|
		<h1>Информация</h1>
		<p>Данный опрос является демо-версией опроса, который запланирован на рождественско-новогодние праздники. Информация, оставленная в этом опросе, не будет учтена при проведении аналитики итогового. Данная демоверсия предназначена только для ознакомления и высказывания критики. Если вы не хотите проходить эту версию опроса или впоследствии проходить опрос повторно, то вам следует воздержаться от участия в демо-версии.</p>
		<p>В этой версии опроса ваши идентификационные признаки привязаны ко всем вашим ответам. Если вы не хотите, чтобы в финальном опросе это осуществлялось, и отказываетесь проходить этот опрос по этой причине, нажмите <a href="decline.html">здесь</a>. Обращаем ваше внимание, что привязка идентификатора ко всем ответам может помочь в отсеивании недобросовестных респондентов на основе заведомо ложных или неверных показаний в любой из частей опроса, а не только в каждом конкретном. Также это может выявить неожиданные корреляции.</p>
		<p>Также обращаем ваше внимание, что в демонстрационной версии можно начать проходить опрос заново даже если вас сдетектируют как уже прошедшего тест, если у вас есть желание оттестировать ещё какой функционал.</p>
		<p>Результаты этой демонстрационной версии не будут опубликованы и будут уничтожены к моменту проведения полной версии опроса.</p>
		<form id="replies" acton="survey.pl" method="post"><input type="hidden" name="task" value="start" />|.FOOTER;
}

sub main_notice {
	return HEADER.q|
		<h1>Информация</h1>
		<p>Пожалуйста, внимательно читайте пояснения к каждому вопросу.</p>
		<p>Данный опрос расчитан на живых людей из реальной жизни. Пожалуйста, воздержитесь от прохождения этого опроса, если вас не существует ИРЛ.</p>
		<p>Данный опрос ориентирован на посетителей сайта IIchan.hk. Если вы не являетесь посетителем данного сайта, или никогда не были на имиджбордах, то некоторые вопросы могут вызвать у вас затруднения. Если вы ничего не знаете об этом сайте, то, возможно, вам не стоит тратить время на этот опрос.</p>
		<p>Результаты опроса будут опубликованы в том числе в разделе /Б/ред сайта IIchan.hk. Поэтому, а также из личных убеждений авторов, в вопрос не были включены чрезмерные расспросы о реальной жизни и другие темы, которые (по мнению авторов) навредили бы проведению опроса, публкации его результатов и их обсуждению. Перечень не получивших освещёния в опросе тем включает в себя: аспекты личной жизни реальных людей, денежный достаток и положение в обществе, политические взгляды, религиозные взгляды, физическое состояние, отношение к нормам общества, причастность к противоправным деяниям и прочие подобные аспекты. Возможно решение по этому вопросу будет пересмотрено в будущем.</p>
		<p>Проходя этот опрос, вы соглашаетесь с обработкой предоставляемых вами данных и их публикацией. В том числе это может означать публикацию любой предоставленной вами в формах опроса информации, включая поля свободного ввода. IP-адрес и идентификационная информация не считаются информацией, предоставляемой в формах, и публиковаться не будут.</p>
		<p>Навигация по страницам опроса осуществляется при помощи кнопок "Назад" и "Сохранить и продолжить" внизу страницы. При переходе на следующую страницу введённые данные сохраняются, чтобы вы могли при необходимости продолжить проходить опрос с того же места, где закончили. При этом следует учитывать, что кнопка "Назад" удаляет все новые данные в формах текущей страницы.</p>
		<form id="replies" acton="survey.pl" method="post"><input type="hidden" name="page" value="0" /><input type="hidden" name="task" value="start" />
			<div>
				<input id="submit" type="submit" value="Сохранить и продолжить" />
				<br />
			</div>
			<br />
		</form>
	</div>
	</body>
</html>|;
}

sub page_1 {
	my (%res) = @_;
	return HEADER.q|
		<h1>Личная информация</h1>
		<p>Перед началом опроса, пожалуйста, расскажите немного о себе. Среди стандартных вопросов этой части, обязательным является только вопрос о том, сколько лет вы провели на бордах, как ключевой фактор в оценке динамики населения досок.</p>
		<p>Поле "Дополнительный комментарий" сугубо опционально и может послужить для вашего рассказа о первом впечатлении, или, если хотите, для более подробного представления себя. Но следует уведомить вас: данное поле скорее всего никак не будет использовано для аналитики.</p>
		<p>Графа "пол" подразумевает биологический пол. Так как опрос расчитан на людей из РЛ, вариант "кошкодевочка" интерпретируется как уход от ответа.<span style="color:white">.. даже если вы на самом деле кошкодевочка, нян!</span></p>
		<form id="replies" action="/survey.pl" method="post" enctype="multipart/form-data">
			<input type="hidden" name="page" value="1" />
			<table><thead>
				<tr>
					<th>Возраст (полных лет)</th>
					<th>Пол</th>
					<th>Пункт проживания</th>
					<th>Суммарный стаж на бордах</th>
				</tr>
			</thead><tbody>
				<tr>
					<td><input name="age" type="number" min="0" |.do {qq|value="$res{age}" | if $res{age}}.q|/></td>
					<td><select name="sex">
						<option value="male"|.do {qq|selected| if $res{male} == 1}.q|>Мужской</option>
						<option value="female"|.do {qq|selected| if $res{male} == 0}.q|>Женский</option>
						<option value="nyan"|.do {qq|selected| if !defined $res{male}}.q|>Кошкодевочка</option>
					</select></td>
					<td><input name="city" type="text" |.do {qq|value="$res{city}" | if $res{city}}.q|/></td>
					<td><input name="board_age" type="number" required min="0" step="0.5" |.do {qq|value="$res{board_age}" | if $res{board_age}}.q| style="width:100%"/></td>
				</tr>
				<tr>
					<th rowspan="3">Дополнительный<br />комментарий</th>
					<td colspan="3"><textarea name="comment">|.do {$res{comments}}.q|</textarea></td>
				</tr>
			</tbody></table>
			|.FOOTER;
}

sub page_2 {
	my (@replies) = @_;
	my $str = HEADER.q|
		<h1>Посещаемые доски</h1>
		<p>Пожалуйста, укажите посещаемые вами - на данный момент или когда-либо - имиджборды. Графу "Первый" стоит отметить, если это был  ваш первый опыт посещения имиджборд. Графу "Основной" следует отмечать для наиболее посещаемых вами на данный момент разделов.</p>
		<p>Если вы посещали раздел в разные периоды времени, пожалуйста, распишите их через ';'. К заполнению обязательна только графа "Имя борды"; необходимо указать хотя бы одну. Допустимо указывать более одного раздела в соответствующей графе.</p>
		<form id="replies" action="/survey.pl" method="post">
			<input type="hidden" name="page" value="2" />
			<table><thead>
				<tr>
					<th>Имя борды</th>
					<th>Раздел</th>
					<th>Период пребывания в разделе</th>
					<th>Первый</th>
					<th>Основной</th>
				</tr></thead><tbody id="visited_boards">
				</tr>
			</table>
			<button type="button" onclick="add_row('pg2')">Добавить доску</button>
			<button type="button" onclick="add_row('pg2',[],'free')">Свой вариант</button>
			<script>|;
	for (@replies) {
		$str .= qq|
				add_row('pg2',['$$_{board}','$$_{subboard}','$$_{stay_period}',$$_{first},$$_{prima}]);|;
	}
	$str .=	q|
			</script>
			<br />|.FOOTER;
	return $str;
}


sub sort_hash_by_val(%) {
	my (%h) = @_;
	return sort {$h{$a} cmp $h{$b}} keys %h;
}

#I am doing something either very wrong or very common and overly implemented otherwhere
sub gen_checkbox_table_from_hash {
	my ($name,$vals,$resp,$opt) = @_;
	$opt = $opt || {};
	my $str;
	unless($$opt{nohead}){
		$str = qq|
				<table id="$name">|;
	}
	my @arr;
	unless($$opt{okeys}){
		@arr = sort_hash_by_val(%{$vals});
	}
	else {
		@arr = @{$$opt{okeys}};
	}
	for (@arr){
		$str .= q|
				<tr>|;
		my $tn = "td";
		$tn = "th" unless $$opt{nohead};
		$str.=qq|
					<$tn class="name">$$vals{$_}</$tn>
					<td|;
		if(defined $$opt{colspan}){
			$str.=qq| colspan="$$opt{colspan}"|;
		}
		$str.=q|><input type=|;
		if($$opt{radio}){
			$str.=q|"radio" |;
		}
		else{
			$str.=q|"checkbox" |;
		}
		if($$resp{$_}) {
			$str .= q|checked |;
		}
		$str .= qq| name="$name" value="$_" autocomplete="off" /></td>
				</tr>|;
	}
	unless($$opt{nohead}) {
		$str .= q|
				</table>|;
	}
	return $str;
}

sub page_3 {
	my $str;
	my ($r_scripts,$r_styles,$r_features,$r_misc) = @_;
	$str = HEADER.q|
		<h1>Используемый и желаемый функционал</h1>
		<form id="replies" actio="survey.pl" method="post">
			<input type="hidden" name="page" value="3" />
			<h3>Используемые клиенты</h3>
			<p>Пожалуйста, укажите используемые вами при посещении имиджборд клиенты. Этот вопрос обязателен. Обращаем ваше внимание, что это не вопрос о пользовательских скриптах.</p>
			<table><thead>
				<tr>
					<th>Наименование клиента</th>
					<th>Причины этого выбора</th>
				</tr></thead><tbody id="clients">
			</tbody></table>
			</table>
			<button type="button" onclick="add_row('pg3.2')">Добавить клиент</button>
			<button type="button" onclick="add_row('pg3.2',[],'free')">Свой вариант</button>
			<script>|;
	for (@{$r_scripts}) {
		if($$_{cat} eq 'client' || !defined $$_{cat}){
			$str .= qq|
				add_row('pg3.2',['$$_{script}','$$_{reason}']);|;
		}
	}
	$str .=	q|
			</script>
			<h3>Используемые скрипты</h3>
			<p>Пожалуйста, укажите используемые вами при посещении имиджборд скрипты. Этот вопрос обязателен. Обращаем ваше внимание, что "Не использую стороннее ПО" уже есть в списке предлагаемых вариантов ответа. Также обращам ваше внимание, что это не вопрос о предпочитаемом клиенте.</p>
			<table><thead>
				<tr>
					<th>Наименование скрипта</th>
					<th>Причины этого выбора</th>
				</tr></thead><tbody id="scripts">
			</tbody></table>
			</table>
			<button type="button" onclick="add_row('pg3.1')">Добавить скрипт</button>
			<button type="button" onclick="add_row('pg3.1',[],'free')">Свой вариант</button>
			<script>|;
	for (@{$r_scripts}) {
		if($$_{cat} eq 'script'|| !defined $$_{cat}){
			$str .= qq|
				add_row('pg3.1',['$$_{script}','$$_{reason}']);|;
		}
	}
	$str .=	q|
			</script>

			<h3>Используемые зеркала</h3>
			<p>Если вы используете зеркала Ычана для его просмотра, пожалуйста, перечислите их в этом вопросе.</p>
			<table><thead>
				<tr>
					<th>Наименование зеркала</th>
					<th>Причины этого выбора</th>
				</tr></thead><tbody id="mirrors">
			</tbody></table>
			</table>
			<button type="button" onclick="add_row('pg3.3',[],'free')">Свой вариант</button>
			<script>|;
	for (@{$r_scripts}) {
		if($$_{cat} eq 'mirror' || !defined $$_{cat}){
			$str .= qq|
				add_row('pg3.3',['$$_{script}','$$_{reason}'],'free');|;
		}
	}
	$str .=	q|
			</script>

			<h3>Используемые стили</h3>
			<p>Пожалуйста, укажите используемые и предпочитаемые вами (css-)стили имиджборд. Обращаем ваше внимание, что это не вопрос о поддерживаемых на посещаемых вами имиджбордах стилях или стилях по умолчанию, и не о стилях, разрабатываемых и/или поддерживаемых вами. Этот вопрос не является обязательным, но отсутствие ответа на него будет трактоваться как отсутствие любимых стилей на имиджбордах.</p>|;
	my %styles = (photon=>'Фотон', futaba=>'Футаба', gurobchan=>'Гурочан', burichan=>'Буричан', icefairy=>'Icefairy', tomorrow=>'Tomorrow', autumn=>'Autumn', umnochan=>'Umnochan', bluemoon=>'Bluemoon', kusaba=>'Kusaba', yotsuba=>'Yotsuba', akkarin=>'Akkarin');
	$str .= gen_checkbox_table_from_hash('stylesheets',\%styles,$r_styles);
	$str .= q|
			<button type="button" onclick="add_row('pg3.4')">Добавить стиль</button>
			<script>|;
	for (sort keys %{$r_styles}) {
		unless(defined $styles{$_}){
			$str .= qq|
				add_row('pg3.4',['$_']);|;
		}
	}
	$str .=	q|
			</script>

			<h3>Используемый и желаемый функционал</h3>
			<p>Пожалуйста, укажите ваше отношение к существующему функционалу на имиджбордах.</p>
			<p>В базовой конфигурации вам предлагается оценить набор ныне-стандартных функций, что не были доступны в стандартных сборках движков имиджборд десять лет назад. Предоставлены три варианта оценки: "Необходимо" без этого функционала вам трудно находиться на доске, и вы будете всячески искать способы добавить его в случае его отсутствия. "Желательно" - функционал, которым бы вы пользовались при случае, но не расстроитесь от его отсутствия. "Безразлично" - когда вам без разницы, существует ли данный функционал или нет.</p>
			<p>Опция "Повседневный функционал" добавляет базовые функции, кроме постинга и просмотра тредов. Опция "эззотерика" добавляет редко встречающийся или устаревший функционал. Опция "Функционал модераторов" добавляет возможность высказаться по функционалу для модерирования доски.</p>
			<p>Этот вопрос не является обязательным. Отсутствие ответов не интерпретируется в счёт какого-либо из критериев.</p>
			<p>В случае, если вам хочется высказаться о конкретных деталях имплементации какого-либо функционала, или же выразить своё негодование по поводу существования такового, пожалуйста, воспользуйтесь графой "Дополнительные комментарии о функциональности движков имиджборд и стороннем ПО" в низу страницы.</p>|;
	my %tr = (default=>'Основной нестандартный функционал', use=>'Стандартный функционал',essoteric=>'Редкий функционал',mod=>'Функионал модерации',hate=>'Нелюбимый функционал');
	my %features = (default => {open_inplace=>'Раскрытие изображений', reply_map => 'Карта ответов', autoreload => 'Подгрузка постов', catalogue => 'Каталог', hide => 'Скрытие', autohide => 'Автоскрытие', autospoiler => 'Автораскрытие спойлера',rss => 'RSS и нотификации',inline_links => 'Встраивание видео по ссылке',https=>'https',nocaptcha_pass=>'Код на постинг без капчи',infinite_board_size=>'Резиновая доска'}, 
		use => {spoiler=> 'Спойлер',bold=>'Полужирное начертание',italic=>'Курсив',code=>'Моноширинный текст',striked=>'Зачёркнутый текст',quote=>'>Цитирование',reply=>'>>Ответ',flash_file=>'Возможность прикреплять .swf',image_file=>'Возможность прикреплять изображения',music_file=>'Возможность прикреплять музыку',video_file=>'Возможность прикреплять видео',arbitrary_file=>'Возможность прикреплять произвольный файл',text_only=>'Постинг без изображения (текстовая доска)',img_spoiler=>'Спойлер-картинка',trip=>'Трипкод',secure_trip=>'Защищённый трипкод',name=>'Имя',email=>'Email',sage=>'Не поднимать тред',noko=>'Возврат к треду',bump=>'Поднять тред',post_del=>'Удаление постов',topic=>'Тема',lists=>'Списки'},
		mod => {mod_post_edit=>'Редактирование поста модерацией',nanoban=>'Нанобан',spam_filter=>'Спамфильтр',word_filter=>'Вордфильтр',image_filter=>'Картинкофильтр (в том числе защита от повторного постинга)',arbitrary_input_filter=>'Фильтрация других частей поста/запроса',captcha=>'Капча',thread_move=>'Перенос треда',thread_close=>'Закрытие треда',arch=>'Архивация треда',autoarch=>'Автоархивация',autoban=>'Автобан',del_all=>'del_all',mod_manage=>'Система привилегий модсостава',thread_timeout=>'Автоудаление треда (по времени и достижении страницы)',contact_form=>'Форма обратной связи',report=>'Кнопка жалобы',iptables_ban=>'Уровни бана (ридонли->нет доступа в раздел->сайт не открывается)',thread_pin=>'Закрепить тред',flood_protection=>'Защита от флуда'},
	essoteric => {crossboard_reply=>'>>>Ссылка на пост другого раздела',post_edit=>'Редактирование собственных постов',ban_notify=>'Извещение о собственном бане',poster_id=>'ID постера',OP_eq_mod=>'ОП может модерировать тред',thread_ips=>'Счётчик пользователей в треде',API=>'API',multiple_upload=>'Прикрепление нескольких файлов',infinite_scroll=>'Бесконечная нулевая',registration=>'$регистрация',karma=>'Карма',infinite_thread_size=>'Отсутствие бамплимита','(You)'=>'Подсвечивание адресованных вам постов',sfw_mode=>'SFW-режим',i2p=>'i2p',tor=>'tor',ascii=>'ascii','shift-JIS'=>'Shift-JIS',emoji=>'Emoji',r9k=>'Robot 9000',user_boards=>'Пользовательские доски',oekaki=>'Оекаки',custom_captcha=>'Нестандартная капча',multiline_formatting=>'Многострочная разметка',autoscroll=>'Нерезиновые треды',flags=>'Флаги'});
	my %tr = (default=>'Основной не стандартный функционал', use=>'Стандартный функционал',essoteric=>'Редкий функционал',mod=>'Функионал модерации');
	for my $id ('default', 'use', 'essoteric', 'mod') {
		$str .= qq|
			<input style="width:auto"" type="checkbox" name="$id" |;
		if ($id eq 'default') {
			$str.=q|checked readonly onclick="return false"|;
		}
		elsif ($$r_misc{$id}) {
			$str.=q|checked |;
		}
		$str.=qq|onclick="toggle_visibility('$id')" autocomplete="off"/>
			<b>$tr{$id}</b>
			<div id="$id"|;
		unless ($id eq 'default') {
			if ($$r_misc{$id}) {
				$str .= q| style="display:block"|;
			}
			else {
				$str .= q| style="display:none"|;
			}
		}
		my %r = reverse %{$features{$id}};
		$str.=q|>|;
		$str.=rb_chart(\%r, $r_features, ['req','useful','dc','unnes','hate'],['Необходимо','Желательно','Безразлично','Нежелательно','Неприемлемо']);
		$str .= q|
			</div><br/>|;
	}
	$str .= qq|
			<p style="margin-bottom: 0px"><b>Используемые вами баги движков имиджборд (обход вордфильтра, смена направления текста и другие)</b></p>
			<textarea name="bug_abuse">$$r_misc{bug_abuse}</textarea>
			<br />
			<p style="margin-bottom: 0px"><b>Дополнительные комментарии о функциональности движков имиджборд и стороннем ПО</b></p>
			<textarea name="feature_comment" style="margin-bottom: 20px">$$r_misc{feature_comment}</textarea>
		|.FOOTER;
	return $str;
}

sub rb_chart {
	my ($h,$r,$tmpl,$tran) = @_;
	my $str = '';
		$str .= q|
		<table><thead><tr>|;
	my (@tmp, @tr);
	if (defined $tmpl) {
		@tmp = @{$tmpl};
	}
	else {
		@tmp = (-2..2);
	}
	if(defined $tran){
		@tr = @{$tran};
	}
	else{
		@tr = ('Негативно','Скорее негативно','Безразлично','Скорее позитивно','Позитивно');
	}
	for ('',@tr) {
		$str .= qq|
			<th>$_</th>|;
	}
	$str .= q|
		</tr></thead><tbody>|;
	for my $topic (sort keys %{$h}) {
		$str .= qq|
		<tr><th class="name">$topic</th>|;
		for my $val (@tmp) {
			if ($val eq 'dc') {
				$str .= qq|
				<td><input type="radio" name="$$h{$topic}" value="dc" |;
				if($$r{$$h{$topic}} eq 'dc' || ! defined $$r{$$h{$topic}}){
					$str.=q|checked |;
				}
				$str.=q|autocomplete="off" /></td>|;
			}
			else {
				$str .= qq|
				<td><input type="radio" name="$$h{$topic}" value="$val" |;
				if($$r{$$h{$topic}} eq $val){
					$str.=q|checked |;
				}
				$str.=q|autocomplete="off" /></td>|;
			}
		}
	}
	return $str.q|
		</tr></tbody></table>|;
}

sub page_5 {
	my ($r_misc) = @_;
	my $str;
 	$str = HEADER.qq|
		<h1>Отношение к происходящему на Ычане</h1>
		<p>Пожалуйста, укажите ваше отношение к событиям и явлениям на Ычане. Если у вас отсутствует мнение (или недостаточно знаний о) каком-либо вопросе - пожалуйста, оставьте оценку в позиции "Индифферентно".</p>
		<p>Этот вопрос не является обязательным. Отсутствие ответа интерпретируется как индифферентность.</p>
		<form id="replies" action="/survey.pl" method="post">
			<input type="hidden" name="page" value="5" />
			<h3>Отношение к модерации</h3>
			<input id="mod_full" type="hidden" name="mod_full" value="$$r_misc{mod_full}" autocomplete="off"/>|;

	$str .= rb_chart({'Общее мнение'=>'mod_overall'},$r_misc);
	$str .= q|
			<button type="button" onclick="toggle_visibility('mod_extended');document.getElementById('mod_full').setAttribute('value',1^document.getElementById('mod_full').getAttribute('value'))">Оценить представителей по отдельности</button>
			<div id="mod_extended" style="display:none">|;
	$str .= rb_chart({'Суровость наказаний'=>'mod_severity','Качество обратной связи'=>'mod_reply','Единство модераторской политики'=>'mod_discrepancy','Закрытие досок'=>'mod_boards_closed','Закрытость /gf/'=>'mod_gf','Эти дни'=>'mod_days','Оживление тематики'=>'mod_revive','Добавление нового функционала'=>'mod_func','Отключение капчи в разделах'=>'mod_nocaptcha'},$r_misc);

	$str .= qq|
				Комментарий: <textarea name="mod_other">$$r_misc{mod_other}</textarea>
			</div>|;
	if($$r_misc{mod_full}){
		$str.=q|<script>toggle_visibility('mod_extended');</script>|;
	}
	$str.=qq|
			<h3>Отношение к локальным мемам и явлениям</h3>
			<input id="meme_full" type="hidden" name="meme_full" value="$$r_misc{meme_full}" autocomplete="off"/>|;
	$str .= rb_chart({'Общее отношение'=>'meme_overall'},$r_misc);
	$str .= q|
			<button type="button" onclick="toggle_visibility('meme_extended');document.getElementById('meme_full').setAttribute('value',1^document.getElementById('meme_full').getAttribute('value'))">Оценить представителей по отдельности</button>
			<div id="meme_extended" style="display:none">|;
	$str .= rb_chart({'Сырно'=>'meme_cirno','Рика Нипа'=>'meme_rika','Злокот'=>'meme_evilcat','Интерактивные рассказы'=>'meme_iirpg','Ротация имён в разделах'=>'meme_name_rotation','Внутрибордовые чаты'=>'meme_chat','Конгломерат'=>'meme_conglomerate','Официальные представительства на сторонних ресурсах'=>'meme_twitter','Бесконечное Лето (игра)'=>'meme_eroge','Бесконечное лето (субкультура)'=>'meme_bl','Нубтайп'=>'meme_noobtype','Околоычанское радио'=>'meme_radio','Мод-тян'=>'meme_mod-tan','Маскоты'=>'meme_mascot','День Ю'=>'meme_you_day'},$r_misc);
	$str .= qq|
				Комментарий: <textarea name="meme_other">$$r_misc{meme_other}</textarea>
			</div>|;
	if($$r_misc{meme_full}){
		$str.=q|<script>toggle_visibility('meme_extended');</script>|;
	}
	$str.=qq|
			<h3>Отношение к персоналиям</h3>
			<input id="fag_full" type="hidden" name="fag_full" value="$$r_misc{fag_full}" autocomplete="off"/>|;
	$str .= rb_chart({'Общее отношение к нейм-/трип- и аватаркофагам'=>'fag_overall'},$r_misc);
	$str .= q|
			<button type="button" onclick="toggle_visibility('fag_extended');document.getElementById('fag_full').setAttribute('value',1^document.getElementById('fag_full').getAttribute('value'))">Оценить представителей по отдельности</button>
			<div id="fag_extended" style="display:none">|;
 	$str .= rb_chart({'Соус-кун'=>'fag_sauce-kun','Lolbot'=>'fag_lb','Кроля'=>'fag_ears','Dyor'=>'fag_dyor','Мицгол'=>'fag_mithgol','Сена'=>'fag_sena','Коакум'=>'fag_koa','Суйгинта.джпг'=>'fag_suiginta.jpg','Eastern Heretic'=>'fag_EH','ГМ-тян'=>'fag_hidziri','Сыр'=>'fag_cheese','Техподдержка-кун'=>'fag_techsupport','jScarlet'=>'fag_jscarlet','СО2'=>'fag_co2','FDC (в целом)'=>'fag_nodolls',"Fox'y"=>'fag_foxy'},$r_misc);
	$str .= qq|
				Другие: <textarea name="fag_other" placeholder="Пожалуйста, указывайте активных, больше не появляющихся, персонажей из чатиков и личностей, не присутствующих на Ычане, раздельно.">$$r_misc{fag_other}</textarea>
			</div>|;
	if($$r_misc{fag_full}){
		$str.=q|<script>toggle_visibility('fag_extended');</script>|;
	}
	$str.=qq|
			<h3>Другое</h3>
			<div>|;
	$str .= rb_chart({'Общее отношение к Ычану'=>'iichan_overall'},$r_misc);
	$str.=q|
			</div>
			<br />|.FOOTER;
	return $str;
}

sub page_8 {
	my (%r_misc) = @_;
	my $str;
	$str = HEADER.q|
		<h1>Оценка опроса</h1>
		<form id="replies" action="/survey.pl" method="post">
		<input type="hidden" name="page" value="8" />|;
=begin comment
	my %resp;
	if(ref($$r_misc{passed_surveies}) eq 'ARRAY') {
		%resp = map { $_, 1 } @{$$r_misc{passed_surveies}};
	}
	else {
		%resp = ($$r_misc{passed_surveies} => 1);
	}
	$str .= gen_checkbox_table_from_hash('passed_surveies',{2009=>'Большая перепись анонимуса',2012=>'Перепись nanimo.me'},\%resp);
=end comment
=cut
	$str .= rb_chart({'Покрытие тем'=>'coverage','Лёгкость прохождения'=>'easiness','Дизайн'=>'design'},\%r_misc);
	$str.=qq|
			<br />
			<h4>Отзывы и технические замечания</h4>
			<textarea name="2017_report" style="width:100%">$r_misc{'2017_report'}</textarea>
			<br />|;
	$str .= FOOTER;
}

sub prefinal {
	my $id = shift;
	return HEADER.qq|
		<h4>Последний шанс изменить ответы. Со следующей страницы пути назад нет.</h3>
		<form action="/survey.pl" method="post"><input type="hidden" name="page" value="9" />|.FOOTER;
}

sub final($){
	my $id = shift;
	return HEADER.qq|
		<h4>Спасибо за участие в опросе.</h4>
	</body>
</html>|;
}

sub page_6 { #act. 6
	my (%r_misc) = @_;
	my $str;
	$str.=HEADER.q|
		<h1>Предпочтения в железе и софте</h1>
		<p>N.B.: Данный вопрос практически полностью ориентирован на пользователей ПК.</p>
		<form id="replies" action="/survey.pl" method="post">
		<input type="hidden" name="page" value="6" />|;
	my %s = (browser=>['Firefox (1-4)','Firefox (5-36)','Firefox (37-57)','Firefox Quantum','Chrome','IE','Edge','Opera (1-15)','Opera (15+)'],videoplayer=>['WMP','VLC','mpc','mpv','MPC-HC','Надстройка над mpv'],audioplayer=>['Foobar2000','Winamp','AIMP','mpv','cmus','mpg123','deedbeef','amaroc','mpd','Стандартный системный плеер'],imageviewer=>['XnView','ACDSee','IrfanView','Стандартный'],vidgets=>['Conky','Rainmeter','Shimeji','Nanika','Скрепка','Стандартные'],text_editor=>['Notepad','Notepad++','Microsoft Word','Libre/Open Office Writer','vim','emacs','Sublime Text'],os=>['Windows XP','Windows Vista','Windows 7','Windows 8','Windows 10','Windows 2000','Windows Me','DOS','Windows 95','Windows 98','HP_UNIX','Arch Linux','Debian','Fedora','Red Hat','Ubuntu','Linux Mint','Gentoo','Slackware','FreeBSD','Mac OS','iOS','Android','OpenSUSE','CentOS']);
	my %h = (smartphone=>['Apple','HTC','Samsung','Blackberry','Nokia','Sony','LG','Huavei'],mobile_operator=>['МТС','Мегафон','Beeline'],gpu=>['Nvidia','AMD'],cpu=>['Intel','AMD'],mouse=>['Любая дешёвая','Logitech','Razer','Microsoft',],headphones=>['Любые дешёвые','ATH','Sony','Apple','JBL','AKG','Beats','Senheiser'],monitor=>['Asus','Acer','Apple','HP','LG','BenQ','Samsung','Phillips','Dell','Fujitsu','Lenovo']);
	my %tr = (browser=>'Браузер',videoplayer=>'Видеопроигрыватель',audioplayer=>'Аудиопроигрыватель',imageviewer=>'Просмотрщик изображений',vidgets=>'Виджеты',text_editor=>'Текстовый редактор',os=>'OS',mobile_operator=>'Оператор',internet_provider=>'Провайдер',gpu=>'GPU',cpu=>'CPU',misc=>'Другие компоненты',mouse=>'Мышь',headphones=>'Наушники',monitor=>'Монитор',smartphone=>'Смартфон');
	for (sort keys %s) {
		$str.=qq|
		<h3>$tr{$_}</h3>
		<table><tbody id="$_">|;
		my %tmp = map {$_ => $_} @{$s{$_}};
		my %resp = map { $_, 1 } @{$r_misc{$_}};
		unless($_ eq 'vidgets' or $_ eq 'browser'){
			$str.=gen_checkbox_table_from_hash($_,\%tmp,\%resp,{nohead=>1});
		}
		else{
			$str.=gen_checkbox_table_from_hash($_,\%tmp,\%resp,{nohead=>1,okeys=>$s{$_}});
		}
		$str.=qq|</tbody></table>
		<table>
			<tr><td colspan="2"><button type="button" onclick="add_row('$_')">Свой вариант</button></td></tr>
		</table>
		<script>|;
		my @t;
		for my $ans (@{$r_misc{$_}}){
			if(!$tmp{$ans}){
				$str.=qq|add_row('$_',['$ans']);|;
			}
		}
		$str.=q|</script>|;
	}
	for (sort keys %h) {
		$str.=qq|
		<h3>$tr{$_}</h3>
		<table><tbody id="$_">|;
		my %tmp = map {$_ => $_} @{$h{$_}};
		my %resp = map { $_, 1 } @{$r_misc{$_}};
		unless($_ eq 'cellphone'){
			$str.=gen_checkbox_table_from_hash($_,\%tmp,\%resp,{nohead=>1});
		}
		else{
			$str.=gen_checkbox_table_from_hash($_,\%tmp,\%resp,{nohead=>1,okeys=>$h{$_}});
		}
		$str.=qq|</tbody></table>
		<table>
			<tr><td colspan="2"><button type="button" onclick="add_row('$_')">Свой вариант</button></td></tr>
		</table>
		<script>|;
		my @t;
		for my $ans (@{$r_misc{$_}}){
			if(!$tmp{$ans}){
				$str.=qq|add_row('$_',['$ans']);|;
			}
		}
		$str.=q|</script>|;
	}
	$str.=FOOTER;
	return $str;
}

sub YN_radio {
	my $str;
	my ($name, $y) = @_; 
	$str.=qq|<td><b>Да</b><input style="width:25%" type="radio" name="$name" value="1" autocomplete="off" |;
	if($y) {
		$str.=qq|checked |;
	}
	$str.=qq|/></td>
		<td><b>Нет</b><input style="width:25%" type="radio" name="$name" value="" autocomplete="off" |;
	if(!$y) {
		$str.=qq|checked |;
	}
	return $str;
}

sub page_4 {
	my ($r_hobbies,$r_misc) = @_;
	my $str;
	$str = HEADER.q|
		<h1>Увлечения</h1>
		<p>Пожалуйста, укажите ваши хобби и увлечения.</p>
		<p>Этот вопрос не является обязательным. Отсутствие ответа на этот вопрос интерпретируется как отсутствие у вас увлечений.</p>
		<p>Выборка основана на частоте упоминаний того или иного хобби на Ычане а также существовании официальных разделов по интересам. Если ваше хобби не представлено на странице, пожалуйста, воспользуйтесь графой "Другое"</p>
		<p>При оценке количественной характеристики вашего хобби достаточно указывать требуемые величины с точностью до двух порядков. </p>
		<form id="replies" action="/survey.pl" method="post">
			<input type="hidden" name="page" value="4" />|;
	my %hobbies = ('Музыка' => [['playing_music','Играете'], ['composing_music','Сочиняете'], ['listening_music','Слушаете']],
		'Изображения' => [['drawing','Рисуете'],['modelling','Моделируете'],['viewing','Любуетесь'],['taking_pictures','Ведёте фотосъёмку']],
		'Видео' => [['shooting','Ведёте видеосъёмку'],['streaming','Стримите'],['watching','Смотрите фильмы и сериалы'],['watching_anime','Смотрите анимацию']],
		'Софт' => [['coding','Программируете'],['gaming','Играете в видеоигры']],
		'Текст' => [['reading','Читаете книги'],['reading_co','Читаете комиксы/мангу'],['writing','Пишете']],
		'ИРЛ' => [['cosplaying','Косплеите'],['figurine_collecting','Коллекционируете фигурки'], ['tourism','Путешествуете']]);
	my %consumerism = (listening_music=>'val',viewing=>'val',watching=>'title',watching_anime=>'title',gaming=>'title',reading=>'title',reading_co=>'title',figurine_collecting=>'fig',tourism=>'trip',cosplaying=>'fest');
	my %h;

	for my $class ('Изображения','Музыка','Видео','Текст','Софт','ИРЛ') {
		$str .= qq|
			<h3>$class</h3>|;
		for (sort {$$a[1] cmp $$b[1]} @{$hobbies{$class}}) {
			$h{$$_[0]} = 1;
			$str .= qq|
				<div>
					$$_[1]?|;
			if ($$_[0] eq 'draw') {
				$str .= q| <i>Включая фотожабы</i>|;
			}
			$str .= qq|
					<span>
						<table class="yesno">
							<tr>
								<th>Да</th>
								<th>Нет</th>
							</tr>
							<tr>
								<td><input type="radio" name="$$_[0]" value="Y" onclick="document.getElementById('$$_[0]').setAttribute('style','display:block')" |;
			if($$r_hobbies{$$_[0]}){
				$str.='checked ';
			}
			$str.=qq|autocomplete="off" /></td>
								<td><input type="radio" name="$$_[0]" value="" onclick="document.getElementById('$$_[0]').setAttribute('style','display:none')" |;
			unless($$r_hobbies{$$_[0]}){
				$str.='checked ';
			}
			$str.=qq|autocomplete="off" /></td>
							</tr>
						</table>
					</span>
				</div>
				<div id="$$_[0]" |;
			if($$r_hobbies{$$_[0]}){
				$str.=q|style="display:block"|;
			}
			else {
				$str.= q|style="display:none"|;
			}
			$str.=qq|>
				<table style="table-layout:fixed"><thead></thead><tbody>
					<tr>
						<th class="name">Сколько лет увлекаетесь?</th>
						<td colspan="2"><input type="number" name="$$_[0]_howlong" min="0" step="0.5" autocomplete="off" |;
			if($$r_hobbies{$$_[0]}) {
				$str.=qq|value="$$r_hobbies{$$_[0]}[0]"|;
			}
			$str.='/></td>';
			unless($consumerism{$$_[0]}) {
				$str.=qq|
						</tr>
						<tr>
							<th class="name">Делитесь ли вы вашим увлечением с досками?</th>|;
				$str.=YN_radio("$$_[0]_board_shared",$$r_hobbies{$$_[0]}[1]);
				$str.=qq|
						</tr>
						<tr>
							<th class="name">Ориентировано ли ваше увлечение на доски?</th>|;
				$str.=YN_radio("$$_[0]_board_primary",$$r_hobbies{$$_[0]}[2]);
				$str.=qq|
						</tr>
						<tr>
							<th class="name">Публикуется ли ваше бордотворчество где-либо помимо имиджборд? (если применимо)</th>|;
				$str.=YN_radio("$$_[0]_board_exclusive",$$r_hobbies{$$_[0]}[3]);
				$str.=qq|
						</tr>
						<tr>
							<th class="name">Является ли этот вид деятельности вашим основным видом заработка?</th>|;
				$str.=YN_radio("$$_[0]_job_shared",$$r_hobbies{$$_[0]}[4]);
			}
			$str.=qq|
					</tr>
					<tr>
						<th class="name">|;
			my %exc = (coding=>'Сфера интереса',tourism=>'Любимые места для путешествий (страны)',figurine_collection=>'Любимые фирмы',cosplaying=>'Любимые персонажи');
			unless($exc{$$_[0]}) {
				$str.='Любимые жанры';
				if ($consumerism{$$_[0]}) {
					$str.=', произведения, авторы';
				}
			}
			else{
				$str.=$exc{$$_[0]};
			}
			$str.=qq|</th>
						<td colspan="2"><input type="text" name="$$_[0]_genre" |;
			if($$r_hobbies{$$_[0]}[6]) {
				$str.=qq|value="$$r_hobbies{$$_[0]}[6]" |;
			}
			$str.=qq|autocomplete="off"/></td>
					</tr>
					<tr>
						<th class="name">|;
			if($consumerism{$$_[0]} eq 'val'){
				$str.=qq|Размер коллекции (в файлах)|;
			}
			elsif($consumerism{$$_[0]} eq 'title'){
				$str.=qq|Количество тайтлов|;
			}
			elsif($consumerism{$$_[0]} eq 'trip'){
				$str.=q|Количество поездок в год|;
			}
			elsif($consumerism{$$_[0]} eq 'fest'){
				$str.='Количество посещённых мероприятий';
			}
			elsif($consumerism{$$_[0]} eq 'fig'){
				$str.='Размер коллекции';
			}
			elsif(!defined $consumerism{$$_[0]}) {
				$str.='Количество законченных проектов';
			}
			$str.=qq|</th>
						<td colspan="2"><input type="number" name="$$_[0]_collection_size" min="0" autocomplete="off" |;
			if($$r_hobbies{$$_[0]}[5]) {
				$str.=qq|value="$$r_hobbies{$$_[0]}[5]"|;
			}
			$str.=qq|/></td>
					</tr>|;
			if ($$_[0] eq 'playing_music') {
				my %instruments =  ('flute'=>'Духовые','string'=>'Струнные','piano'=>'Клавишные','drum'=>'Ударные');
				my %resp;
				if(ref($$r_misc{$$_[0].'_instrument'}) eq 'ARRAY') {
					%resp = map { $_, 1 } @{$$r_misc{$$_[0].'_instrument'}};
				}
				else {
					%resp = ($$r_misc{$$_[0].'_instrument'}=>1);
				}
				$str.='<tr><th colspan="3">Инструменты</th></tr>';
				$str .= gen_checkbox_table_from_hash($$_[0].'_instrument',\%instruments,\%resp,{colspan=>2,nohead=>1});
				$str.=qq|<tr><th colspan="3">Поимённый перечень</th></tr><tr><td colspan="3"><textarea name="$$_[0]_other">$$r_misc{$$_[0].'_other'}</textarea></td></tr>|;
			}
			elsif ($$_[0] eq 'composing_music') {
				$str.=qq|<tr><th class="name">Количество активных проектов</th><td colspan="2"><input type="number" min="0" name="$$_[0]_act_proj" |;
				if(defined $$r_misc{$$_[0].'_act_proj'}){
					$str.=qq|value="|.$$r_misc{$$_[0].'_act_proj'}.q|" |;
				}
				$str.=qq|/></td></tr>
				<tr><th class="name">Количество законченных композиций</th><td colspan="2"><input type="number" min="0" name="$$_[0]_fin_units" |;
				if(defined $$r_misc{$$_[0].'_fin_units'}){
					$str.=q|value="|.$$r_misc{$$_[0].'_fin_units'}.q|" |;
				}
				$str.=q|/></td></tr>|;
				my %instruments=('FL'=>'FruityLoops','QB'=>'QBase','traditional'=>'Нотный стан');
				my %resp;
				if(ref($$r_misc{$$_[0].'_instrument'}) eq 'ARRAY') {
					%resp = map { $_, 1 } @{$$r_misc{$$_[0].'_instrument'}};
				}
				else {
					%resp = ($$r_misc{$$_[0].'_instrument'}=>1);
				}
				$str.='<tr><th colspan="3">Инструменты</th></tr>';
				$str .= gen_checkbox_table_from_hash($$_[0].'_instrument',\%instruments,\%resp,{colspan=>2,nohead=>1});
				$str.=qq|<tr><th colspan="3">Другие музыкальные редакторы</th></tr><tr><td colspan="3"><textarea name="$$_[0]_other">$$r_misc{$$_[0].'_other'}</textarea></td></tr>|;
			}
			elsif ($$_[0] eq 'listening_music') {
				$str .= qq|
				<tr><th class="name">Слушаете радио?</th>|;
				$str.=YN_radio("$$_[0]_radio", $$r_misc{$$_[0].'_radio'});
				$str.=qq|</tr>
				<tr><th class="name">Lossy или lossless?</th>
					<td style="width:30%"><b>Lossy</b><input style="width:20%" type="radio" name="$$_[0]_lossy" value="lossy" autocomplete="off" |;
				if($$r_misc{$$_[0].'_lossy'} eq 'lossy') {
					$str.=qq|checked |;
				}
				$str.=qq|/></td>
					<td><b>Lossless</b><input style="width:25%" type="radio" name="$$_[0]_lossy" value="lossless" autocomplete="off" |;
				if($$r_misc{$$_[0].'_lossy'} eq 'lossless') {
					$str.=qq|checked |;
				}
				$str.=q|></td>
				</tr>|;
			}
			elsif ($$_[0] eq 'drawing') {
				$str.=qq|<tr><th class="name">Количество активных проектов</th><td colspan="2"><input type="number" min="0" name="$$_[0]_act_proj" |;
				if(defined $$r_misc{$$_[0].'_act_proj'}){
					$str.=qq|value="|.$$r_misc{$$_[0].'_act_proj'}.q|" |;
				}
				$str.=qq|/></td></tr>
				<tr><th class="name">Количество законченных рисунков</th><td colspan="2"><input type="number" min="0" name="$$_[0]_fin_units" |;
				if(defined $$r_misc{$$_[0].'_fin_units'}){
					$str.=q|value="|.$$r_misc{$$_[0].'_fin_units'}.q|" |;
				}
				$str.=q|/></td></tr>|;
				my %instruments=(wacom=>'Wacom',genius=>'Genius',huion=>'Huion',mouse=>'Мышка',paper=>'Традиционные средства');
				my %resp;
				if(ref($$r_misc{$$_[0].'_instrument'}) eq 'ARRAY') {
					%resp = map { $_, 1 } @{$$r_misc{$$_[0].'_instrument'}};
				}
				else {
					%resp = ($$r_misc{$$_[0].'_instrument'}=>1);
				}
				$str.='<tr><th colspan="3">Инструменты</th></tr>';
				$str .= gen_checkbox_table_from_hash($$_[0].'_instrument',\%instruments,\%resp,{colspan=>2,nohead=>1});
				my %software = (sai=>'Paint Tool SAI',ps=>'Photoshop',msp=>'MS Paint',o=>'Онлайн-рисовалки',gimp=>'Gimp',krita=>'Krita',ms=>'Manga Studio',csp=>'Clip Studio Paint','p.net'=>'Paint.NET',gg=>'Graphics Gale');
				if(ref($$r_misc{$$_[0].'_software'}) eq 'ARRAY') {
					%resp = map { $_, 1 } @{$$r_misc{$$_[0].'_software'}};
				}
				else {
					%resp = ($$r_misc{$$_[0].'_software'}=>1);
				}
				$str.='<tr><th colspan="3">Граф. редакторы</th></tr>';
				$str.=gen_checkbox_table_from_hash($$_[0].'_software',\%software,\%resp,{colspan=>2,nohead=>1});
				$str.=qq|<tr><th colspan="3">Дополнительный инструментарий</th></tr><tr><td colspan="3"><textarea name="$$_[0]_other">$$r_misc{$$_[0].'_other'}</textarea></td></tr>|;
			}
			elsif ($$_[0] eq 'modelling') {
				$str.=qq|<tr><th class="name">Количество активных проектов</th><td colspan="2"><input type="number" min="0" name="$$_[0]_act_proj" |;
				if(defined $$r_misc{$$_[0].'_act_proj'}){
					$str.=qq|value="|.$$r_misc{$$_[0].'_act_proj'}.q|" |;
				}
				$str.=qq|/></td></tr>
				<tr><th class="name">Количество законченных моделей</th><td colspan="2"><input type="number" min="0" name="$$_[0]_fin_units" |;
				if(defined $$r_misc{$$_[0].'_fin_units'}){
					$str.=q|value="|.$$r_misc{$$_[0].'_fin_units'}.q|" |;
				}
				$str.=q|/></td></tr>|;
				my %instruments=(wacom=>'Bamboo',huion=>'Huion',genius=>'Genius',mouse=>'Мышка');
				my %resp;
				if(ref($$r_misc{$$_[0].'_instrument'}) eq 'ARRAY') {
					%resp = map { $_, 1 } @{$$r_misc{$$_[0].'_instrument'}};
				}
				else {
					%resp = ($$r_misc{$$_[0].'_instrument'}=>1);
				}
				$str.='<tr><th colspan="2">Инструменты</th></tr>';
				$str .= gen_checkbox_table_from_hash($$_[0].'_instrument',\%instruments,\%resp,{colspan=>2,nohead=>1});
				my %software = ('3dm'=>'3DMax',blender=>'Blender',ma=>'Maya',zbr=>'Zbrush');
				if(ref($$r_misc{$$_[0].'_software'}) eq 'ARRAY') {
					%resp = map { $_, 1 } @{$$r_misc{$$_[0].'_software'}};
				}
				else {
					%resp = ($$r_misc{$$_[0].'_software'}=>1);
				}
				$str.='<tr><th colspan="3">Графические редакторы</th></tr>';
				$str .= gen_checkbox_table_from_hash($$_[0].'_software',\%software,\%resp,{colspan=>2,nohead=>1});
				$str.=qq|<tr><th colspan="3">Дополнительный инструментарий</th></tr><tr><td colspan="3"><textarea name="$$_[0]_other">$$r_misc{$$_[0].'_other'}</textarea></td></tr>|;
			}
			elsif ($$_[0] eq 'taking_pictures') {
				$str.=qq|<tr><th class="name">Количество активных проектов</th><td colspan="2"><input type="number" min="0" name="$$_[0]_act_proj" |;
				if(defined $$r_misc{$$_[0].'_act_proj'}){
					$str.=qq|value="|.$$r_misc{$$_[0].'_act_proj'}.q|" |;
				}
				$str.=qq|/></td></tr>
				<tr><th class="name">Количество снятых фотографий</th><td colspan="2"><input type="number" min="0" name="$$_[0]_fin_units" |;
				if(defined $$r_misc{$$_[0].'_fin_units'}){
					$str.=q|value="|.$$r_misc{$$_[0].'_fin_units'}.q|" |;
				}
				$str.=q|/></td></tr>|;
				$str .= qq|
				<tr>
					<th colspan="3">Инструменты для съёмки и редактуры материала:</th></tr><tr>
					<td colspan="3"><textarea name="$$_[0]_other">$$r_misc{$$_[0].'_other'}</textarea></td>
				</tr>|;
			}
			elsif ($$_[0] eq 'coding') {
				$str.=qq|<tr><th class="name">Количество активных проектов</th><td colspan="2"><input type="number" min="0" name="$$_[0]_act_proj" |;
				if(defined $$r_misc{$$_[0].'_act_proj'}){
					$str.=qq|value="|.$$r_misc{$$_[0].'_act_proj'}.q|" |;
				}
				$str.=qq|/></td></tr>
				<tr><th class="name">Количество строк кода</th><td colspan="2"><input type="number" min="0" name="$$_[0]_fin_units" |;
				if(defined $$r_misc{$$_[0].'_fin_units'}){
					$str.=q|value="|.$$r_misc{$$_[0].'_fin_units'}.q|" |;
				}
				$str.=q|/></td></tr>|;
				my %ide = (notepad=>'Блокнот',vim=>'Vim',emacs=>'Emacs',VS=>'Visual Studio',eclipse=>'Eclipse',geany=>'Geany',cb=>'Code;;Blocks',subl=>'Sublime',atom=>'Atom');
				my %resp;
				if(ref($$r_misc{$$_[0].'_software'}) eq 'ARRAY') {
					%resp = map { $_, 1 } @{$$r_misc{$$_[0].'_software'}};
				}
				else {
					%resp = ($$r_misc{$$_[0].'_software'}=>1);
				}
				$str.='<tr><th colspan="3">IDE</th></tr>';
				$str .= gen_checkbox_table_from_hash($$_[0].'_software',\%ide,\%resp,{colspan=>2,nohead=>1});
				my %lang = (c=>'C',cpp=>'C++',csharp=>'C#',go=>'Go',rust=>'Rust',d=>'D',f=>'F',oc=>'Objective-C',pl=>'Perl',java=>'Java',py=>'Python',hs=>'Haskel',cl=>'Common Lisp',pa=>'Pascal',js=>'JavaScript',ru=>'Ruby',asm=>'*ASM',sh=>'Скрипты командной строки',dom=>'Специфичные языки');
				if(ref($$r_misc{$$_[0].'_lang'}) eq 'ARRAY') {
					%resp = map { $_, 1 } @{$$r_misc{$$_[0].'_lang'}};
				}
				else {
					%resp = ($$r_misc{$$_[0].'_lang'}=>1);
				}
				$str.='<tr><th colspan="3">Языки программирования</th></tr>';
				$str .= gen_checkbox_table_from_hash($$_[0].'_lang',\%lang,\%resp,{colspan=>2,nohead=>1});
				$str.=qq|<tr><th colspan="3">Другие языки и IDE</th></tr><tr><td colspan="3"><textarea name="$$_[0]_other">$$r_misc{$$_[0].'_other'}</textarea></td></tr>|;
			}
			elsif ($$_[0] eq 'modding') {
				$str .= qq|
				<tr>
					<th colspan="3">Игры и инструменты:</th></tr><tr>
					<td colspan="3"><textarea name="$$_[0]_other">$$r_misc{$$_[0].'_other'}</textarea></td>
				</tr>|;
			}
			elsif ($$_[0] eq 'gaming') {
				my %platforms = (wii=>'Wii',pc=>'PC',wiiu=>'WiiU',nds=>'Nintendo DS','3ds'=>'Nintendo 3DS',switch=>'Switch','ps4'=>'PS4','ps3'=>'PS3','ps2'=>'PS2','x360'=>'XBOX 360','xone'=>'XBOX One',psp=>'PSP',psv=>'PSV',phone=>'Смартфон');
				my %resp;
				if(ref($$r_misc{$$_[0].'_platforms'}) eq 'ARRAY') {
					%resp = map { $_, 1 } @{$$r_misc{$$_[0].'_platforms'}};
				}
				else {
					%resp = ($$r_misc{$$_[0].'_platforms'}=>1);
				}
				$str.='<tr><th colspan="3">Платформы</th></tr>';
				$str .= gen_checkbox_table_from_hash($$_[0].'_platforms',\%platforms,\%resp,{colspan=>2,nohead=>1});
				my %genres = ('fps'=>'Шутеры',arcade=>'Аркады',fighting=>'Файтинги',ccg=>'ККИ',strategy=>'Стратегии',puzzle=>'Паззлы',quest=>'Квесты',vn=>'VN',rythm=>'Ритм-игры',moba=>'MOBA',shmup=>'Скролл-шутеры');
				if(ref($$r_misc{$$_[0].'_genres'}) eq 'ARRAY') {
					%resp = map { $_, 1 } @{$$r_misc{$$_[0].'_genres'}};
				}
				else {
					%resp = ($$r_misc{$$_[0].'_genres'}=>1);
				}
				$str.='<tr><th colspan="3">Жанры</th></tr>';
				$str .= gen_checkbox_table_from_hash($$_[0].'_genres',\%genres,\%resp,{colspan=>2,nohead=>1});
				$str .= qq|
				<tr><th class="name">Предпочитаете ли вы играть на языке оригинала?</th>|;
				$str.=YN_radio("$$_[0]_orig_lang", $$r_misc{$$_[0].'_orig_lang'});
				$str.=q|</tr>|;
				$str.=qq|<tr><th colspan="3">Другие консоли и жанры</th></tr><tr><td colspan="3"><textarea name="$$_[0]_other">$$r_misc{$$_[0].'_other'}</textarea></td></tr>|;
			}
			elsif ($$_[0] eq 'shooting') {
				$str.=qq|<tr><th class="name">Количество активных проектов</th><td colspan="2"><input type="number" min="0" name="$$_[0]_act_proj" |;
				if(defined $$r_misc{$$_[0].'_act_proj'}){
					$str.=qq|value="|.$$r_misc{$$_[0].'_act_proj'}.q|" |;
				}
				$str.=qq|/></td></tr>
				<tr><th class="name">Количество отснятых часов</th><td colspan="2"><input type="number" min="0" name="$$_[0]_fin_units" |;
				if(defined $$r_misc{$$_[0].'_fin_units'}){
					$str.=q|value="|.$$r_misc{$$_[0].'_fin_units'}.q|" |;
				}
				$str.=q|/></td></tr>|;
				$str .= qq|
				<tr>
					<th colspan="3">Инструменты для съёмки и редактуры материала:</th></tr><tr>
					<td colspan="3"><textarea name="$$_[0]_specs">$$r_misc{$$_[0].'_specs'}</textarea></td>
				</tr>|;
			}
			elsif ($$_[0] eq 'watching') {
				$str .= qq|
				<tr>
					<th class="name">Предпочитаете ли вы просматривать кино и сериалы  на языке оригинала?</th>|;
				$str.=YN_radio("$$_[0]_orig_lang", $$r_misc{$$_[0].'_orig_lang'});
				$str.=q|</tr>|;
			}
			elsif ($$_[0] eq 'watching_anime') {
				$str .= qq|
				<tr><th class="name">Предпочитаете ли вы просматривать анимацию на языке оригинала?</th>|;
				$str.=YN_radio("$$_[0]_orig_lang", $$r_misc{$$_[0].'_orig_lang'});
				$str.=q|</tr>|;
			}
			elsif ($$_[0] eq 'streaming') {
				$str.=qq|<tr><th class="name">Количество активных проектов</th><td colspan="2"><input type="number" min="0" name="$$_[0]_act_proj" |;
				if(defined $$r_misc{$$_[0].'_act_proj'}){
					$str.=qq|value="|.$$r_misc{$$_[0].'_act_proj'}.q|" |;
				}
				$str.=qq|/></td></tr>
				<tr><th class="name">Количество часов стримов</th><td colspan="2"><input type="number" min="0" name="$$_[0]_fin_units" |;
				if(defined $$r_misc{$$_[0].'_fin_units'}){
					$str.=q|value="|.$$r_misc{$$_[0].'_fin_units'}.q|" |;
				}
				$str.=q|/></td></tr>|;
				$str .= qq|
				<tr>
					<th colspan="3">Платформа и объект стриминга, причина стриминга<th></tr><tr>
					<td colspan="3"><textarea name="$$_[0]_specs">$$r_misc{$$_[0].'_specs'}</textarea></td>
				</tr>|;
			}
			elsif ($$_[0] eq 'writing') {
				$str.=qq|<tr><th class="name">Количество активных проектов</th><td colspan="2"><input type="number" min="0" name="$$_[0]_act_proj" |;
				if(defined $$r_misc{$$_[0].'_act_proj'}){
					$str.=qq|value="|.$$r_misc{$$_[0].'_act_proj'}.q|" |;
				}
				$str.=qq|/></td></tr>
				<tr>
					<th class="name">Объём написанного (кб)</th>
					<td colspan="2"><input type="number" name="$$_[0]_fin_units" min="0" step="0.5" autocomplete="off" |;
				if ($$r_misc{$$_[0].'_fin_units'}) {
					$str.=qq|value="$$r_misc{$$_[0].'_fin_units'}" |;
				}
				$str.=q|/></td>
				</tr>|;
			}
			elsif($$_[0] eq 'reading_co') {
				$str.=qq|
				<tr>
					<th class="name">Вы больше предпочитаете:</th>
					<td style="width:30%"><b>Комиксы</b><input style="width:20%" type="radio" name="reading_co_manga" value="comics" autocomplete="off" |;
				if($$r_misc{reading_co_manga} eq 'comics') {
					$str.=qq|checked |;
				}
				$str.=qq|/></td>
					<td><b>Мангу</b><input style="width:25%" type="radio" name="reading_co_manga" value="manga" autocomplete="off" |;
				if($$r_misc{reading_co_manga} eq 'manga') {
					$str.=qq|checked |;
				}
				$str.=q|/></td></tr>|;
			}
			elsif($$_[0] eq 'figurine_collecting'){
				$str.=qq|<tr><th class="name">Предпочитаемый форм-фактор</th>
				<td colspan="2"><select name="$$_[0]_format">|;
				for my $opt ('','PVC','Figma','Nendroid','Меха','Сборные наборы','Другое'){
					$str.=q|<option|;
					if($$r_misc{$$_[0].'_format'} eq $opt){
						$str.=q| selected|;
					}
					$str.=qq|>$opt</option>|;
				}
				$str.=qq|</select></tr></tr>
				<tr>
					<th colspan="3">Подробности о фигурках и не учтённые вопросы<th></tr><tr>
					<td colspan="3"><textarea name="$$_[0]_specs">$$r_misc{$$_[0].'_specs'}</textarea></td>
				</tr>|;
			}
			elsif($$_[0] eq 'tourism'){
				$str.=qq|<tr><th class="name">Любимые места для путешествий (ладншафт)</th>
					<td colspan="2"><input type="text" name="$$_[0]_landscape" |;
				if($$r_misc{$$_[0].'_landscape'}){
					$str.=q| value="|.$$r_misc{$$_[0].'_landscape'}.q|" |;
				}
				$str.=qq|/></td></tr>
					<tr><th class="name">Предпочитаемое средство передвижения</th>
					<td colspan="2"><input type="text" name="$$_[0]_tr" |;
				if($$r_misc{$$_[0].'_tr'}){
					$str.=q| value="|.$$r_misc{$$_[0].'_tr'}.q|" |;
				}
				$str.=q|/></td></tr>|;
			}
			$str .= q|</tbody></table>
			</div>
			<hr />|;
		}
	}
	# Add waifus?
	$str .= q|
			<h3>Другое</h3>
			<p>Пожалуйста, перечислите здесь хобби, для которых не было предоставлено готовых форм.</p>
			<div id="other_hobby">
			</div>
			<button type="button" onclick="add_row('pg4')">Добавить хобби</button>
			<script>|;
	my $c = 0;
	for (sort keys %{$r_hobbies}) {
		if (!$h{$_} and $_) {
			$str.=qq|add_row('pg4',['$_',|.join(', ', @{$$r_hobbies{$_}}).q|'|.$$r_misc{$_.'_other'}.q|']);|;
			$c+=1;
		}
	}
	unless($c) {
		$str.=qq|add_row('pg4',[,,,,,,]);|;
	}
	$str.=q|
			</script>
			<br />|.FOOTER;
	return $str;
}

sub page_7 {
	my (%r_misc) = @_;
	my $str;
	$str.=HEADER.qq|
		<h1>Форм-фактор</h1>
		<p>Данный вопрос является продолжением предыдущих двух вопросов и предлагает уточнить особенности потребления медиаконтента, не зависящие от предпочитаемого ПО.</p>|;
	my %q = (monitor=>['16:9','16:10','4:3','Другое'],resolution=>['меньше 240p','480p','720p','1080p','больше 1080p'],monitor_num=>['1','2','3','4','5+'],headph=>['Затычки','Клипсы','Мониторные наушники','Гарнитура','Не использую наушники'],iichan=>['ПК','Планшет','Телефон','Тонкий клиент','Другое'],computer=>['ПК','Ноутбук'],proxy=>['Общедоступные прокси','Платные прокси','Личный VPN','TOR','Без проксирующих соединений'],https=>['https','http','ssh'],mouse=>['1','2','3','5-6','7+'],keyboard=>['Урезанная (меньше 90 клавиш)','Стандартная (примерно 104 клавиш)','С дополнительными клавишами']);
	#Also keabord and mouth no of buttons
	my %tr = (monitor=>'Формат экрана',resolution=>'Разрешение экрана',monitor_num=>'Количество мониторов',headph=>'Форм-фактор наушников',iichan=>'Основное устройство для выхода в Ычанск',computer=>'Форм-фактор компьютера',proxy=>'Использование проксирующих запросов',https=>'Основной протокол общения с Ычаном',mouse=>'Количество клавиш мыши',keyboard=>'Формат клавиатуры');
	$str.=qq|
		<form id="replies" action="/survey.pl" method="post">
			<input type="hidden" name="page" value="7" />|;
	for (sort keys %q) {
		$str.=qq|
		<h3>$tr{$_}</h3>
		<table><tbody id="$_">|;
		my %tmp = map {$_ => $_} @{$q{$_}};
		my %resp = map { $_, 1 } @{$r_misc{$_}};
		$str.=gen_checkbox_table_from_hash($_,\%tmp,\%resp,{radio=>1,nohead=>1,okeys=>$q{$_}});
		$str.=q|</tbody></table>|;
	}
	$str.=FOOTER;
	return $str;
}



1;
